﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Grid_DisableRows
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

        }

        private void igGrid_CellControlAttached(object sender, Infragistics.Controls.Grids.CellControlAttachedEventArgs e)
        {
            e.Cell.Row.Control.Style = (sender as XamGrid).Resources["IsEnabledStyle"] as Style;
        }
    }

    public class WViewModel : INotifyPropertyChanged
    {

        ObservableCollection<Worker> listOfWorkers;

        public WViewModel()
        {
            listOfWorkers = new ObservableCollection<Worker>();

            listOfWorkers.Add(new Worker("Vivian", 22, "QA", true));
            listOfWorkers.Add(new Worker("Andy", 23, "DS", true));
            listOfWorkers.Add(new Worker("Peter", 24, "QA", true));
            listOfWorkers.Add(new Worker("Vivian", 22, "QA", true));
            listOfWorkers.Add(new Worker("Andy", 23, "DS", false));
            listOfWorkers.Add(new Worker("Vivian", 22, "QA", true));
            listOfWorkers.Add(new Worker("Andy", 23, "DS", false));
            listOfWorkers.Add(new Worker("Peter", 22, "QA", true));

            listOfWorkers.Add(new Worker("Peter", 24, "QA", true));

        }

        public ObservableCollection<Worker> ListOfWorkers
        {
            get { return listOfWorkers; }

            set
            {
                if (value != listOfWorkers)
                {
                    listOfWorkers = value;
                    OnPropertyChanged("ListOfWorkers");
                }
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

    }

    public class Worker : INotifyPropertyChanged
    {
        public Worker() { }

        public Worker(string name, int age, string job, bool enabled)
        {
            this.Name = name;
            this.Age = age;
            this.JobTitle = job;
            this.IsEnabled = enabled;
        }


        private string name;

        public string Name
        {
            get
            {
                return this.name;
            }

            set
            {
                if (value != this.name)
                {
                    this.name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }

        private int age;

        public int Age
        {
            get
            {
                return this.age;
            }

            set
            {
                if (value != this.age)
                {
                    this.age = value;
                    NotifyPropertyChanged("Age");
                }
            }
        }


        private string jobTitle;

        public string JobTitle
        {
            get
            {
                return this.jobTitle;
            }

            set
            {
                if (value != this.jobTitle)
                {
                    this.jobTitle = value;
                    NotifyPropertyChanged("JobTitle");
                }
            }
        }

        private bool myVar;

        public bool IsEnabled
        {
            get { return myVar; }
            set { myVar = value; NotifyPropertyChanged("IsEnabled"); }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


    }
}
